#include <iostream>
#include <vector>
#include <map>
#include <set>
using namespace std;

class Matrix {
public:
    vector<pair<long long int, long long int>>  inputs;
    vector<pair<long long int, long long int>>  volcanoes;
    vector<bool>                                empty; //vztahuje se k volcanoes

    vector<int> pathLengths;

    long long int x_max, x_min, y_max, y_min;
    long long int x_neg, y_neg;

    int getInputs() {
        unsigned long long int  in = 0;
        long long int           x = 0, y = 0;

        cin >> in;

        if(in == 0) return 0;

        inputs.resize(in);

        for(unsigned long long int i = 0; i < in; i++) {
            cin >> x >> y;
            if(i == 0) {
                x_min = x;
                x_max = x;
            }
            setNewMinMax(x, y);
            inputs[i] = make_pair(x, y);
        }

        if( x_min < 0 ) x_neg = abs(x_min);
        else x_neg = 0;
        if( y_min < 0 ) y_neg = abs(y_min);
        else y_neg = 0;

        return 1;
    }

    void fillVolcanoes() {
        volcanoes.resize((x_max + x_neg + 1), make_pair(0, 0));
        empty.resize((x_max + x_neg + 1), true);

        //pro kazdy vstup
        for( auto elem: inputs ) {
            long long int x = elem.first + x_neg;
            long long int y = elem.second;

            //kdyz je prvni vstup pro urcite x
            if( empty[x] ) {
                volcanoes[x].first = y;
                volcanoes[x].second = y;
                empty[x] = false;
                continue;
            }

            if( y < volcanoes[x].first ) volcanoes[x].first = y;
            if( y > volcanoes[x].second ) volcanoes[x].second = y;

        }
    }

    void path(long long int x, long long int start_y, long long int dist) {

        if(empty[x]) {
            path(x + 1, start_y, dist + 1);
        }

        long long int minimum = volcanoes[x].first;
        long long int max = volcanoes[x].second;

        if( x == x_max + x_neg ){
            dist += min((distance(start_y, max) + distance(max, minimum)), (distance(start_y, minimum) + distance(minimum, max)));
            pathLengths.push_back(dist);
            return;
        }

        path(x + 1, minimum, dist + distance(start_y, max) + distance(max, minimum) + 1);
        path(x + 1, max, dist + distance(start_y, minimum) + distance(minimum, max) + 1);
    }

    int shortestPath(){
        long long int start_x = x_min + x_neg;
        path( start_x, volcanoes[start_x].first, 0 );
        path( start_x, volcanoes[start_x].second, 0 );

        long long int shortest = pathLengths[0];
        for( auto elem: pathLengths) {
            if( elem < shortest ) shortest = elem;
        }

        return shortest;
    }
/*
    int getFirst() {
        long long int start_x = x_min + x_neg;
        int max_dist = min(distance(volcanoes[start_x].first, volcanoes[start_x+1].first), distance(volcanoes[start_x].first, volcanoes[start_x+1].second) );
        int min_dist = min(distance(volcanoes[start_x].second, volcanoes[start_x+1].first), distance(volcanoes[start_x].second, volcanoes[start_x+1].second) );
        if(max_dist < min_dist) return volcanoes[start_x].first;
        return volcanoes[start_x].second;
    }*/


/*
    int pathLength() {
        long long int start_x = x_min + x_neg;
        long long int end_x = x_max + x_neg;

        long long int prev_y = getFirst();

        long long int dist = 0;

        for( long long int i = start_x; i <= end_x; i++ ) {
            long long int min = volcanoes[i].first;
            long long int max = volcanoes[i].second;
            //prechod na vyssi x
            dist ++;

            if( empty[i] ) continue;

            if( prev_y <= min ){
                dist += distance(prev_y, max);
                prev_y = max;
                continue;
            }
            if( prev_y > min ) {
                dist += distance(prev_y, min);
                prev_y = min;
                continue;
            }
            if( distance(prev_y, min) <= distance( prev_y, max ) ) {
                dist += distance(prev_y, min);
                dist += distance(min, max);
                prev_y = max;
                continue;
            }
            if(distance( prev_y, max ) < distance( prev_y, min ) ) {
                dist += distance(prev_y, max);
                dist += distance(max, min);
                prev_y = min;
                continue;
            }

            cout << dist << endl;
            int tmp;
            cin >> tmp;

        }
        return dist - 1;
    }
*/
    int distance( long long int x, long long int y ) {
        if( x > y ) return x - y;
        return y -x;
    }

    void setNewMinMax(long long int x, long long int y) {
        if( x > x_max ) x_max = x;
        if( x < x_min ) x_min = x;
    }

    //TODO: smazat
    void print(){
        for( auto elem: inputs ) {
            cout << elem.first << " " << elem.second << endl;
        }
        cout << "X: " << x_min << " - " << x_max << endl;

        cout << "Volcanoes" << endl;
        for( auto elem: volcanoes ) {
            cout << elem.first << " " << elem.second << endl;
        }
    }
};

int main() {
    Matrix matrix;

    if(matrix.getInputs() == 0 ) return 0;

    matrix.fillVolcanoes();

    cout << matrix.shortestPath() << endl;

    //matrix.print();

    return 0;
}